## org.hibernate.type
Class CollectionType

    java.lang.Object
      org.hibernate.type.AbstractType
          org.hibernate.type.CollectionType

All Implemented Interfaces:
  Serializable, AssociationType, Type

Direct Known Subclasses:
  ArrayType, BagType, CustomCollectionType, IdentifierBagType, ListType, MapType, SetType

    public abstract class CollectionType

extends AbstractType
implements AssociationType

A type that handles Hibernate `PersistentCollection`s (including arrays).

See Also:
  Serialized Form

Field Summary
`static Object` `UNFETCHED_COLLECTION`

Fields inherited from class org.hibernate.type.AbstractType
`LEGACY_DEFAULT_SIZE, LEGACY_DICTATED_SIZE`

Constructor Summary
`CollectionType(TypeFactory.TypeScope typeScope, String role, String foreignKeyPropertyName, boolean isEmbeddedInXML)`

Method Summary
`Object` `assemble(Serializable cached, SessionImplementor session, Object owner)` Reconstruct the object from its disassembled state.
`int` `compare(Object x, Object y)` Perform a `Comparator` style comparison between values
`boolean` `contains(Object collection, Object childObject, SessionImplementor session)`
`Object` `deepCopy(Object value, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Size[]` `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Serializable` `disassemble(Object value, SessionImplementor session, Object owner)` Return a disassembled representation of the object.
`Object` `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`String` `getAssociatedEntityName(SessionFactoryImplementor factory)` Get the entity name of the associated entity
`Joinable` `getAssociatedJoinable(SessionFactoryImplementor factory)` Get the "persister" for this association - a class or collection persister
`Object` `getCollection(Serializable key, SessionImplementor session, Object owner)` instantiate a collection wrapper (called when loading an object)
`int` `getColumnSpan(Mapping session)` How many columns are used to persist this type.
`protected Iterator` `getElementsIterator(Object collection)` Get an iterator over the element set of the collection in POJO mode
`Iterator` `getElementsIterator(Object collection, SessionImplementor session)` Get an iterator over the element set of the collection, which may not yet be wrapped
`Type` `getElementType(SessionFactoryImplementor factory)` Get the Hibernate type of the collection elements
`ForeignKeyDirection` `getForeignKeyDirection()` Get the foreign key directionality of this association
`int` `getHashCode(Object x)` Get a hash code, consistent with persistence "equality".
`Serializable` `getIdOfOwnerOrNull(Serializable key, SessionImplementor session)` Get the id value from the owning entity key, usually the same as the key, but might be some other property, in the case of property-ref
`Serializable` `getKeyOfOwner(Object owner, SessionImplementor session)` Get the key value from the owning entity instance, usually the identifier, but might be some other unique key, in the case of property-ref
`String` `getLHSPropertyName()` Get the name of a property in the owning entity that provides the join key (null if the identifier)
`String` `getName()` Returns the abbreviated name of the type.
`String` `getOnCondition(String alias, SessionFactoryImplementor factory, Map enabledFilters)` Get the "filtering" SQL fragment that is applied in the SQL on clause, in addition to the usual join condition
`String` `getRHSUniqueKeyPropertyName()` The name of a unique property of the associated entity that provides the join key (null if the identifier of an entity, or key of a collection)
`String` `getRole()`
`boolean` `hasHolder()`
`Object` `hydrate(ResultSet rs, String[] name, SessionImplementor session, Object owner)` Extract a value from the JDBC result set.
`Object` `indexOf(Object collection, Object element)`
`protected boolean` `initializeImmediately()`
`abstract Object` `instantiate(int anticipatedSize)` Instantiate an empty instance of the "underlying" collection (not a wrapper), but with the given anticipated size (i.e.
`abstract PersistentCollection` `instantiate(SessionImplementor session, CollectionPersister persister, Serializable key)` Instantiate an uninitialized collection wrapper or holder.
`protected Object` `instantiateResult(Object original)` Instantiate a new "underlying" collection exhibiting the same capacity charactersitcs and the passed "original".
`boolean` `isAlwaysDirtyChecked()` We always need to dirty check the collection because we sometimes need to incremement version number of owner and also because of how assemble/disassemble is implemented for uks
`boolean` `isArrayType()`
`boolean` `isAssociationType()` Note: return true because this type is castable to `AssociationType`.
`boolean` `isCollectionType()` Return true if the implementation is castable to `CollectionType`.
`boolean` `isDirty(Object old, Object current, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isDirty(Object old, Object current, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isEmbeddedInXML()`
`boolean` `isEqual(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` `isModified(Object old, Object current, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` `isMutable()` Are objects of this type mutable.
`boolean` `isXMLElement()`
`Object` `nullSafeGet(ResultSet rs, String[] name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`Object` `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, boolean[] settable, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`protected String` `renderLoggableString(Object value, SessionFactoryImplementor factory)`
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` `replaceElements(Object original, Object target, Object owner, Map copyCache, SessionImplementor session)` Replace the elements of a collection with the elements of another collection.
`Object` `resolve(Object value, SessionImplementor session, Object owner)` The second phase of 2-phase loading.
`Object` `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` `sqlTypes(Mapping session)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.
`String` `toString()`
`boolean` `useLHSPrimaryKey()` Is the primary key of the owning entity table to be used in the join?
`abstract PersistentCollection` `wrap(SessionImplementor session, Object collection)` Wrap the naked collection instance in a wrapper, or instantiate a holder.

Methods inherited from class org.hibernate.type.AbstractType
`beforeAssemble, getHashCode, getSemiResolvedType, isAnyType, isComponentType, isEntityType, isEqual, isSame, replace, replaceNode`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.hibernate.type.Type
`beforeAssemble, getHashCode, getReturnedClass, getSemiResolvedType, isAnyType, isComponentType, isEntityType, isEqual, isSame, replace`

Field Detail

### UNFETCHED_COLLECTION

    public static final Object UNFETCHED_COLLECTION

Constructor Detail

### CollectionType

    public CollectionType(TypeFactory.TypeScope typeScope,
                          String role,
                          String foreignKeyPropertyName,
                          boolean isEmbeddedInXML)

Method Detail

### isEmbeddedInXML

    public boolean isEmbeddedInXML()

  Specified by:
    `isEmbeddedInXML` in interface `AssociationType`

### getRole

    public String getRole()

### indexOf

    public Object indexOf(Object collection,
                          Object element)

### contains

    public boolean contains(Object collection,
                            Object childObject,
                            SessionImplementor session)

### isCollectionType

    public boolean isCollectionType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `CollectionType`. Essentially a polymorphic version of `(type instanceof CollectionType.class)`

  A `CollectionType` is additionally an `AssociationType`; so if this method returns true, `Type.isAssociationType()` should also return true.

  Specified by:
    `isCollectionType` in interface `Type`
  Overrides:
    `isCollectionType` in class `AbstractType`
  Returns:
    True if this type is also an `CollectionType` implementor; false otherwise.

### isEqual

    public final boolean isEqual(Object x,
                                 Object y)

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Specified by:
    `isEqual` in interface `Type`
  Overrides:
    `isEqual` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered equal (see discussion above).

### compare

    public int compare(Object x,
                       Object y)

  Description copied from interface: `Type`
  Perform a `Comparator` style comparison between values

  Specified by:
    `compare` in interface `Type`
  Overrides:
    `compare` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### getHashCode

    public int getHashCode(Object x)

  Description copied from interface: `Type`
  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Specified by:
    `getHashCode` in interface `Type`
  Overrides:
    `getHashCode` in class `AbstractType`
  Parameters:
    `x` - The value for which to retrieve a hash code
  Returns:
    The hash code

### instantiate

    public abstract PersistentCollection instantiate(SessionImplementor session,
                                                     CollectionPersister persister,
                                                     Serializable key)

  Instantiate an uninitialized collection wrapper or holder. Callers MUST add the holder to the persistence context!

  Parameters:
    `session` - The session from which the request is originating.
    `persister` - The underlying collection persister (metadata)
    `key` - The owner key.
  Returns:
    The instantiated collection.

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String name,
                              SessionImplementor session,
                              Object owner)
                       throws SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `SQLException` - An error from the JDBC driver

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String[] name,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeSet

    public final void nullSafeSet(PreparedStatement st,
                                  Object value,
                                  int index,
                                  boolean[] settable,
                                  SessionImplementor session)
                           throws HibernateException,
                                  SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter. Implementors should handle the possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `settable` - an array indicating which columns to bind/ignore
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int index,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### sqlTypes

    public int[] sqlTypes(Mapping session)
                   throws MappingException

  Description copied from interface: `Type`
  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `sqlTypes` in interface `Type`
  Parameters:
    `session` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    public Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `dictatedSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    public Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Description copied from interface: `Type`
  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `defaultSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getColumnSpan

    public int getColumnSpan(Mapping session)
                      throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Specified by:
    `getColumnSpan` in interface `Type`
  Parameters:
    `session` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### toLoggableString

    public String toLoggableString(Object value,
                                   SessionFactoryImplementor factory)
                            throws HibernateException

  Description copied from interface: `Type`
  Generate a representation of the value for logging purposes.

  Specified by:
    `toLoggableString` in interface `Type`
  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation
  Throws:
    `HibernateException` - An error from Hibernate

### renderLoggableString

    protected String renderLoggableString(Object value,
                                          SessionFactoryImplementor factory)
                                   throws HibernateException

  Throws:
    `HibernateException`

### deepCopy

    public Object deepCopy(Object value,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Specified by:
    `deepCopy` in interface `Type`
  Parameters:
    `value` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy
  Throws:
    `HibernateException` - An error from Hibernate

### getName

    public String getName()

  Description copied from interface: `Type`
  Returns the abbreviated name of the type.

  Specified by:
    `getName` in interface `Type`
  Returns:
    String the Hibernate type name

### getElementsIterator

    public Iterator getElementsIterator(Object collection,
                                        SessionImplementor session)

  Get an iterator over the element set of the collection, which may not yet be wrapped

  Parameters:
    `collection` - The collection to be iterated
    `session` - The session from which the request is originating.
  Returns:
    The iterator.

### getElementsIterator

    protected Iterator getElementsIterator(Object collection)

  Get an iterator over the element set of the collection in POJO mode

  Parameters:
    `collection` - The collection to be iterated
  Returns:
    The iterator.

### isMutable

    public boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Specified by:
    `isMutable` in interface `Type`
  Returns:
    boolean

### disassemble

    public Serializable disassemble(Object value,
                                    SessionImplementor session,
                                    Object owner)
                             throws HibernateException

  Description copied from interface: `Type`
  Return a disassembled representation of the object. This is the value Hibernate will use in second level caching, so care should be taken to break values down to their simplest forms; for entities especially, this means breaking them down into their constituent parts.

  Specified by:
    `disassemble` in interface `Type`
  Overrides:
    `disassemble` in class `AbstractType`
  Parameters:
    `value` - the value to cache
    `session` - the originating session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException` - An error from Hibernate

### assemble

    public Object assemble(Serializable cached,
                           SessionImplementor session,
                           Object owner)
                    throws HibernateException

  Description copied from interface: `Type`
  Reconstruct the object from its disassembled state. This method is the reciprocal of `Type.disassemble(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

  Specified by:
    `assemble` in interface `Type`
  Overrides:
    `assemble` in class `AbstractType`
  Parameters:
    `cached` - the disassembled state from the cache
    `session` - the originating session
    `owner` - the parent entity object
  Returns:
    the (re)assembled object
  Throws:
    `HibernateException` - An error from Hibernate

### isDirty

    public boolean isDirty(Object old,
                           Object current,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Overrides:
    `isDirty` in class `AbstractType`
  Parameters:
    `old` - the old value
    `current` - the current value
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isDirty

    public boolean isDirty(Object old,
                           Object current,
                           boolean[] checkable,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `old` - the old value
    `current` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### wrap

    public abstract PersistentCollection wrap(SessionImplementor session,
                                              Object collection)

  Wrap the naked collection instance in a wrapper, or instantiate a holder. Callers MUST add the holder to the persistence context!

  Parameters:
    `session` - The session from which the request is originating.
    `collection` - The bare collection to be wrapped.
  Returns:
    The wrapped collection.

### isAssociationType

    public boolean isAssociationType()

  Note: return true because this type is castable to `AssociationType`. Not because all collections are associations.

  Specified by:
    `isAssociationType` in interface `Type`
  Overrides:
    `isAssociationType` in class `AbstractType`
  Returns:
    True if this type is also an `AssociationType` implementor; false otherwise.

### getForeignKeyDirection

    public ForeignKeyDirection getForeignKeyDirection()

  Description copied from interface: `AssociationType`
  Get the foreign key directionality of this association

  Specified by:
    `getForeignKeyDirection` in interface `AssociationType`

### getKeyOfOwner

    public Serializable getKeyOfOwner(Object owner,
                                      SessionImplementor session)

  Get the key value from the owning entity instance, usually the identifier, but might be some other unique key, in the case of property-ref

  Parameters:
    `owner` - The collection owner
    `session` - The session from which the request is originating.
  Returns:
    The collection owner's key

### getIdOfOwnerOrNull

    public Serializable getIdOfOwnerOrNull(Serializable key,
                                           SessionImplementor session)

  Get the id value from the owning entity key, usually the same as the key, but might be some other property, in the case of property-ref

  Parameters:
    `key` - The collection owner key
    `session` - The session from which the request is originating.
  Returns:
    The collection owner's id, if it can be obtained from the key; otherwise, null is returned

### hydrate

    public Object hydrate(ResultSet rs,
                          String[] name,
                          SessionImplementor session,
                          Object owner)

  Description copied from interface: `Type`
  Extract a value from the JDBC result set. This is useful for 2-phase property initialization - the second phase is a call to `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` This hydrated value will be either:
  - in the case of an entity or collection type, the key
  - otherwise, the value itself

  Specified by:
    `hydrate` in interface `Type`
  Overrides:
    `hydrate` in class `AbstractType`
  Parameters:
    `rs` - The JDBC result set
    `name` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    An entity or collection key, or an actual value.
  See Also:
    `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### resolve

    public Object resolve(Object value,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException

  Description copied from interface: `Type`
  The second phase of 2-phase loading. Only really pertinent for entities and collections. Here we resolve the identifier to an entity or collection instance

  Specified by:
    `resolve` in interface `Type`
  Overrides:
    `resolve` in class `AbstractType`
  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `session` - the session
    `owner` - the parent entity
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException` - An error from Hibernate
  See Also:
    `Type.hydrate(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### semiResolve

    public Object semiResolve(Object value,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException

  Description copied from interface: `Type`
  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Specified by:
    `semiResolve` in interface `Type`
  Overrides:
    `semiResolve` in class `AbstractType`
  Parameters:
    `value` - The unresolved, hydrated value
    `session` - THe originating session
    `owner` - The value owner
  Returns:
    The semi-resolved value
  Throws:
    `HibernateException` - An error from Hibernate

### isArrayType

    public boolean isArrayType()

### useLHSPrimaryKey

    public boolean useLHSPrimaryKey()

  Description copied from interface: `AssociationType`
  Is the primary key of the owning entity table to be used in the join?

  Specified by:
    `useLHSPrimaryKey` in interface `AssociationType`

### getRHSUniqueKeyPropertyName

    public String getRHSUniqueKeyPropertyName()

  Description copied from interface: `AssociationType`
  The name of a unique property of the associated entity that provides the join key (null if the identifier of an entity, or key of a collection)

  Specified by:
    `getRHSUniqueKeyPropertyName` in interface `AssociationType`

### getAssociatedJoinable

    public Joinable getAssociatedJoinable(SessionFactoryImplementor factory)
                                   throws MappingException

  Description copied from interface: `AssociationType`
  Get the "persister" for this association - a class or collection persister

  Specified by:
    `getAssociatedJoinable` in interface `AssociationType`
  Throws:
    `MappingException`

### isModified

    public boolean isModified(Object old,
                              Object current,
                              boolean[] checkable,
                              SessionImplementor session)
                       throws HibernateException

  Description copied from interface: `Type`
  Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` here/

  Specified by:
    `isModified` in interface `Type`
  Overrides:
    `isModified` in class `AbstractType`
  Parameters:
    `old` - the database state, in a "hydrated" form, with identifiers unresolved
    `current` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException` - A problem occurred performing the checking

### getAssociatedEntityName

    public String getAssociatedEntityName(SessionFactoryImplementor factory)
                                   throws MappingException

  Description copied from interface: `AssociationType`
  Get the entity name of the associated entity

  Specified by:
    `getAssociatedEntityName` in interface `AssociationType`
  Throws:
    `MappingException`

### replaceElements

    public Object replaceElements(Object original,
                                  Object target,
                                  Object owner,
                                  Map copyCache,
                                  SessionImplementor session)

  Replace the elements of a collection with the elements of another collection.

  Parameters:
    `original` - The 'source' of the replacement elements (where we copy from)
    `target` - The target of the replacement elements (where we copy to)
    `owner` - The owner of the collection being merged
    `copyCache` - The map of elements already replaced.
    `session` - The session from which the merge event originated.
  Returns:
    The merged collection.

### instantiateResult

    protected Object instantiateResult(Object original)

  Instantiate a new "underlying" collection exhibiting the same capacity charactersitcs and the passed "original".

  Parameters:
    `original` - The original collection.
  Returns:
    The newly instantiated collection.

### instantiate

    public abstract Object instantiate(int anticipatedSize)

  Instantiate an empty instance of the "underlying" collection (not a wrapper), but with the given anticipated size (i.e. accounting for initial capacity and perhaps load factor).

  Parameters:
    `anticipatedSize` - The anticipated size of the instaniated collection after we are done populating it.
  Returns:
    A newly instantiated collection to be wrapped.

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache)
                   throws HibernateException

  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### getElementType

    public final Type getElementType(SessionFactoryImplementor factory)
                              throws MappingException

  Get the Hibernate type of the collection elements

  Parameters:
    `factory` - The session factory.
  Returns:
    The type of the collection elements
  Throws:
    `MappingException` - Indicates the underlying persister could not be located.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getOnCondition

    public String getOnCondition(String alias,
                                 SessionFactoryImplementor factory,
                                 Map enabledFilters)
                          throws MappingException

  Description copied from interface: `AssociationType`
  Get the "filtering" SQL fragment that is applied in the SQL on clause, in addition to the usual join condition

  Specified by:
    `getOnCondition` in interface `AssociationType`
  Throws:
    `MappingException`

### getCollection

    public Object getCollection(Serializable key,
                                SessionImplementor session,
                                Object owner)

  instantiate a collection wrapper (called when loading an object)

  Parameters:
    `key` - The collection owner key
    `session` - The session from which the request is originating.
    `owner` - The collection owner
  Returns:
    The collection

### hasHolder

    public boolean hasHolder()

### initializeImmediately

    protected boolean initializeImmediately()

### getLHSPropertyName

    public String getLHSPropertyName()

  Description copied from interface: `AssociationType`
  Get the name of a property in the owning entity that provides the join key (null if the identifier)

  Specified by:
    `getLHSPropertyName` in interface `AssociationType`

### isXMLElement

    public boolean isXMLElement()

  Specified by:
    `isXMLElement` in interface `Type`
  Overrides:
    `isXMLElement` in class `AbstractType`

### fromXMLNode

    public Object fromXMLNode(org.dom4j.Node xml,
                              Mapping factory)
                       throws HibernateException

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Specified by:
    `fromXMLNode` in interface `Type`
  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`
  Throws:
    `HibernateException` - An error from Hibernate

### setToXMLNode

    public void setToXMLNode(org.dom4j.Node node,
                             Object value,
                             SessionFactoryImplementor factory)
                      throws HibernateException

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Specified by:
    `setToXMLNode` in interface `Type`
  Parameters:
    `node` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory
  Throws:
    `HibernateException` - An error from Hibernate

### isAlwaysDirtyChecked

    public boolean isAlwaysDirtyChecked()

  We always need to dirty check the collection because we sometimes need to incremement version number of owner and also because of how assemble/disassemble is implemented for uks

  Specified by:
    `isAlwaysDirtyChecked` in interface `AssociationType`

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Specified by:
    `toColumnNullness` in interface `Type`
  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.